unit Unit1;

interface

uses Windows, Classes, Controls, Forms, registry, sysutils, mmsystem, shellapi,
     Dialogs, MPlayer, messages, colorbtn, ComCtrls, StdCtrls, ExtCtrls,
  AppEvnts;

const RegKey = 'SOFTWARE\CooolTimer\Options';
      WM_MYMES = $8003;
      My_MES = $8004; 

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    UpDown3: TUpDown;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    StaticText1: TStaticText;
    MediaPlayer1: TMediaPlayer;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    CheckBox2: TCheckBox;
    ColorBtn1: TColorBtn;
    ColorBtn2: TColorBtn;
    CheckBox3: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit1Change(Sender: TObject);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown3Click(Sender: TObject; Button: TUDBtnType);
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox2Click(Sender: TObject);
    procedure ColorBtn1Click(Sender: TObject);
    procedure ColorBtn2Click(Sender: TObject);
    procedure MediaPlayer1Notify(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ShutDown;
    procedure DrawTime;
    procedure WMGetMyMes(var Msg:TMessage); message WM_MYMES;
    procedure WMGetTrayMes(var Msg:TMessage); message My_MES;
    procedure ControlWindow(Var Msg:TMessage); message WM_SYSCOMMAND;
    procedure TrayControl(Var Msg:TMessage); message WM_COMMAND;
  end;

function ExitWindowsEx(uFlags:LongWord; dwReserved:LongWord):Boolean;stdcall;external 'user32.dll' name 'ExitWindowsEx';  

var
  Form1: TForm1;
  INIReg: TRegInifile;
  Thour,Tmin,Tsec:integer;
  Chour,Cmin,Csec:integer;
  PrevSec,PrevMls,TargSec:integer;
  systime:SYSTEMTIME;
  TimerID:longint;
  activ:boolean;
  MigC:integer=0;
  my:notifyicondata;
  hm:hmenu;

implementation

{$R *.dfm}

procedure TForm1.DrawTime;
 var m,h,s:word;
     sm,sh,ss:string;
begin
 h:=TargSec div 3600;
 m:=(TargSec-(h*3600)) div 60;
 s:=TargSec-(h*3600)-(m*60);
 if h<10 then sh:='0'+inttostr(h) else sh:=inttostr(h);
 if m<10 then sm:='0'+inttostr(m) else sm:=inttostr(m);
 if s<10 then ss:='0'+inttostr(s) else ss:=inttostr(s);
 form1.StaticText1.Caption:=sh+':'+sm+':'+ss;
 application.Title:=' '+form1.StaticText1.Caption;
 if checkbox3.Checked then begin
  for m:=1 to 9 do
   my.szTip[m-1]:=form1.StaticText1.Caption[m];
  shell_notifyicon(NIM_MODIFY,@my);
 end;
end;

function GetWinVersion: string;
 var VersionInfo: TOSVersionInfo;
begin
 VersionInfo.dwOSVersionInfoSize:=SizeOf(TOSVersionInfo);
 if Windows.GetVersionEx(VersionInfo) then begin
  with VersionInfo do begin
   case dwPlatformId of
    VER_PLATFORM_WIN32s: Result:='Win32s';
    VER_PLATFORM_WIN32_WINDOWS:Result:='Windows 95';
    VER_PLATFORM_WIN32_NT: Result:='Windows NT';
   end;
  end;
 end else Result:='';
end;

procedure TForm1.ShutDown;
const
  SE_SHUTDOWN_NAME = 'SeShutdownPrivilege'; 
var
  hToken: THandle;
  tkp: TTokenPrivileges;
  tkpo: TTokenPrivileges;
  zero: DWORD;
  cn:TCloseAction;
begin
  cn:=caNone;
  Form1.FormClose(nil,cn);
  if (GetWinVersion='Windows NT') then begin
   zero:=0;
   if not OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then
   begin
    MessageBox(0, 'Exit Error', 'OpenProcessToken() Failed', MB_OK);
    Exit;
   end;             

   if not OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then
   begin
    MessageBox(0, 'Exit Error', 'OpenProcessToken() Failed', MB_OK);
    Exit;
   end;

   if not LookupPrivilegeValue( nil, 'SeShutdownPrivilege', tkp.Privileges[0].Luid ) then
   begin
    MessageBox(0, 'Exit Error', 'LookupPrivilegeValue() Failed', MB_OK);
    Exit;
   end; 
   tkp.PrivilegeCount := 1;
   tkp.Privileges[0].Attributes:=SE_PRIVILEGE_ENABLED;
   AdjustTokenPrivileges(hToken, False, tkp, SizeOf(TTokenPrivileges), tkpo, zero);
   if Boolean(GetLastError) then begin
    MessageBox(0, 'Exit Error', 'AdjustTokenPrivileges() Failed', MB_OK);
    Exit;
   end else ExitWindowsEx(EWX_FORCE or EWX_SHUTDOWN, 0);
  end else ExitWindowsEx(EWX_FORCE or EWX_SHUTDOWN, 0);
end;

procedure CallBack(TimerID, uMessage: UINT;dwUser, dw1, dw2: DWORD)stdcall;
 var delta:integer;
begin
 if activ then
  if targsec>0 then begin //    
   GetLocalTime(systime);
   if (prevsec<>systime.wSecond)and(systime.wMilliseconds>Prevmls) then begin
    if systime.wSecond>prevsec then delta:=systime.wSecond-prevsec
       else delta:=60-prevsec+systime.wSecond; //  ,       
    TargSec:=TargSec-delta;
    if TargSec<0 then TargSec:=0;
    postmessage(form1.Handle,WM_MYMES,2,0); // Draw time
    prevsec:=systime.wSecond;

    if targsec=0 then begin  // ALARM !
     application.Restore;
     SetWindowPos(form1.Handle,HWND_TOP,form1.Left,form1.Top,form1.Width,form1.Height,SWP_SHOWWINDOW);
     BringWindowToTop(form1.Handle);
     SetForegroundWindow(form1.Handle);
     SetActiveWindow(form1.Handle);
     if form1.Tag=2 then postmessage(form1.Handle,My_MES,0,WM_LBUTTONDBLCLK);
     if form1.CheckBox2.Checked then postmessage(form1.Handle,WM_MYMES,1,0) //power off
     else if (form1.checkbox1.checked=false)and(form1.OpenDialog1.FileName<>'')and
      (fileexists(form1.OpenDialog1.FileName)) then postmessage(form1.Handle,WM_MYMES,0,0);//alarm
    end;
   end;
  end else if form1.CheckBox2.Checked=false then begin //        
   inc(MigC);
   if MigC=10 then begin
    form1.StaticText1.color:=65535;
    form1.StaticText1.Font.Color:=0;
   end;
   if MigC=20 then begin
    form1.StaticText1.color:=0;
    form1.StaticText1.Font.Color:=255;
    MigC:=0;
   end;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 if form1.Tag=1 then begin  // Tag=1   
  form1.Tag:=0;
  CheckBox3Click(nil);
 end;
 edit2.SetFocus;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 UpDown1.Position:=abs(strtoint(edit1.Text));
 if RadioButton1.Checked then begin
  Thour:=UpDown1.Position;
 end else begin
  if UpDown1.Position>23 then UpDown1.Position:=23;
  Chour:=UpDown1.Position;
 end;
 edit1.Text:=inttostr(UpDown1.Position);
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
 UpDown2.Position:=abs(strtoint(edit2.Text));
 if UpDown2.Position>59 then UpDown2.Position:=59;
 if RadioButton1.Checked then begin
  Tmin:=UpDown2.Position;
 end else begin
  Cmin:=UpDown2.Position;
 end;
 edit2.Text:=inttostr(UpDown2.Position);
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
 UpDown3.Position:=abs(strtoint(edit3.Text));
 if UpDown3.Position>59 then UpDown3.Position:=59;
 if RadioButton1.Checked then begin
  Tsec:=abs(strtoint(edit3.Text));
 end else begin
  Csec:=abs(strtoint(edit3.Text));
 end;
 edit3.Text:=inttostr(UpDown3.Position);
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
 if RadioButton1.Checked then begin
  UpDown1.Max:=100; //       
  edit1.Text:=inttostr(thour);
  edit2.Text:=inttostr(tmin);
  edit3.Text:=inttostr(tsec);
  form1.Caption:='Timer';
  application.Title:='Timer';
  my.szTip:='Timer';
 end else begin
  UpDown1.Max:=24;
  edit1.Text:=inttostr(chour);
  edit2.Text:=inttostr(cmin);
  edit3.Text:=inttostr(csec);
  form1.Caption:='Alarm clock';
  application.Title:='Alarm clock';
  my.szTip:='Alarm clock';
 end;
 if checkbox3.Checked then shell_notifyicon(NIM_MODIFY,@my);
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 if (Button=ComCtrls.btPrev) and (updown1.Position=updown1.Min) then updown1.Position:=updown1.Max-1;
 if (Button=ComCtrls.btNext) and (updown1.Position=updown1.Max) then updown1.Position:=updown1.Min+1;
 edit1.Text:=inttostr(updown1.Position);
end;

procedure TForm1.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
 if (Button=ComCtrls.btPrev) and (updown2.Position=updown2.Min) then updown2.Position:=updown2.Max-1;
 if (Button=ComCtrls.btNext) and (updown2.Position=updown2.Max) then updown2.Position:=updown2.Min+1;
 edit2.Text:=inttostr(updown2.Position);
end;

procedure TForm1.UpDown3Click(Sender: TObject; Button: TUDBtnType);
begin
 if (Button=ComCtrls.btPrev) and (updown3.Position=updown3.Min) then updown3.Position:=updown3.Max-1;
 if (Button=ComCtrls.btNext) and (updown3.Position=updown3.Max) then updown3.Position:=updown3.Min+1;
 edit3.Text:=inttostr(updown3.Position);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 my.cbSize:=sizeof(notifyicondata);
 my.Wnd:=form1.Handle;
 my.uID:=1;
 my.uFlags:=nif_icon or nif_message or nif_tip;
 my.hIcon:=loadicon(hinstance,'MAINICON');
 my.uCallbackMessage:=my_mes;
 
 hm:=CreatePopupMenu;
 AppendMenu(hm,MF_STRING,1,'');
 AppendMenu(hm,MFT_SEPARATOR,3,nil);
 AppendMenu(hm,MF_STRING,0,'');

 INIReg:=TRegInifile.Create;
 form1.Top:=INIReg.ReadInteger(RegKey,'FormTop',(GetSystemMetrics(SM_CYSCREEN)-form1.height) div 2);
 form1.Left:=INIReg.ReadInteger(RegKey,'FormLeft',(GetSystemMetrics(SM_CXSCREEN)-form1.Width) div 2);
 Thour:=INIReg.ReadInteger(RegKey,'Thour',0);
 Tmin:=INIReg.ReadInteger(RegKey,'Tmin',0);
 Tsec:=INIReg.ReadInteger(RegKey,'Tsec',0);
 Chour:=INIReg.ReadInteger(RegKey,'Chour',0);
 Cmin:=INIReg.ReadInteger(RegKey,'Cmin',0);
 Csec:=INIReg.ReadInteger(RegKey,'Csec',0);
 OpenDialog1.FileName:=INIReg.ReadString(RegKey,'FileName','');
 RadioButton1.Checked:=INIReg.ReadBool(RegKey,'Timer',True);
 Checkbox1.Checked:=INIReg.ReadBool(RegKey,'Mute',false);
 Checkbox2.Checked:=INIReg.ReadBool(RegKey,'Shut',false);
 Checkbox3.Checked:=INIReg.ReadBool(RegKey,'Tray',false);
 INIReg.CloseKey;
 INIReg.Free;
 RadioButton2.Checked:= not(RadioButton1.Checked);
 RadioButton1Click(nil);
 CheckBox2Click(nil);
 if OpenDialog1.FileName<>'' then begin
  OpenDialog1.InitialDir:=ExtractFilePath(opendialog1.Filename);;
  if fileexists(OpenDialog1.FileName) then begin
   ColorBtn1.Hint:='Alarm file: '+opendialog1.FileName;
   ColorBtn1.Caption:='Redefine alarm file';
  end;
 end;
 doublebuffered:=true;
 panel1.DoubleBuffered:=true;
 ColorBtn1.ButtonColor:=15780518;
 ColorBtn2.ButtonColor:=15780518;
 MediaPlayer1.TimeFormat:=tfMilliseconds;
 activ:=false;
 TimerID:=timeSetEvent(11,11,@CallBack,0,TIME_PERIODIC);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 shell_notifyicon(nim_delete,@my);
 activ:=false;
 timeKillEvent(TimerID);
 if ColorBtn2.tag=1 then ColorBtn2Click(nil);
 INIReg:=TRegInifile.Create;
 INIReg.WriteInteger(RegKey,'FormTop',form1.Top);
 INIReg.WriteInteger(RegKey,'FormLeft',form1.Left);
 INIReg.WriteInteger(RegKey,'Thour',Thour);
 INIReg.WriteInteger(RegKey,'Tmin',Tmin);
 INIReg.WriteInteger(RegKey,'Tsec',Tsec);
 INIReg.WriteInteger(RegKey,'Chour',Chour);
 INIReg.WriteInteger(RegKey,'Cmin',Cmin);
 INIReg.WriteInteger(RegKey,'Csec',Csec);
 INIReg.WriteString(RegKey,'FileName',OpenDialog1.FileName);
 INIReg.WriteBool(RegKey,'Mute',Checkbox1.Checked);
 INIReg.WriteBool(RegKey,'Timer',RadioButton1.Checked);
 INIReg.WriteBool(RegKey,'Shut',Checkbox2.Checked);
 INIReg.WriteBool(RegKey,'Tray',Checkbox3.Checked);
 INIReg.CloseKey;
 INIReg.Free;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if ((byte(key)<48) and (byte(key)<>8)) or (byte(key)>57) then key:=#0;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 if CheckBox2.Checked then begin
  CheckBox2.Font.Color:=255;
  CheckBox1.Visible:=false;
  ColorBtn1.Visible:=false;
 end else begin
  CheckBox1.Visible:=true;
  ColorBtn1.Visible:=true;
  CheckBox2.Font.Color:=0;
 end; 
end;

procedure TForm1.WMGetMyMes(var Msg:TMessage);
begin
 case Msg.WParam of
 0: begin
     MediaPlayer1.Tag:=1;
     MediaPlayer1.FileName:=form1.OpenDialog1.FileName;
     MediaPlayer1.Open;
     MediaPlayer1.Play;
    end;
 1: ShutDown;
 2: DrawTime;
 end;
end;

procedure TForm1.WMGetTrayMes(var Msg:TMessage);
 var  t:tpoint;
begin
 case Msg.LParam of
 WM_LBUTTONDBLCLK: if form1.Tag=0 then begin   // 
  ShowWindow(Handle,SW_HIDE);
  form1.Tag:=2;   //   
  ModifyMenu(hm,0,MF_BYPOSITION	or MF_STRING,1,'')
 end else begin                                // 
  ShowWindow(Form1.Handle,SW_SHOW);
  application.Restore;
  form1.BringToFront;
  SetWindowPos(form1.Handle,HWND_TOP,form1.Left,form1.Top,form1.Width,form1.Height,SWP_SHOWWINDOW);
  BringWindowToTop(form1.Handle);
  SetForegroundWindow(form1.Handle);
  SetActiveWindow(form1.Handle);
  form1.Tag:=0; //   
  ModifyMenu(hm,0,MF_BYPOSITION	or MF_STRING,1,'')
 end;
 WM_RBUTTONUP: begin
  getcursorpos(t);
  SetForegroundWindow(form1.Handle);
  TrackPopupMenuEx(hm,TPM_BOTTOMALIGN or TPM_RIGHTALIGN or TPM_RIGHTBUTTON or TPM_LEFTBUTTON,t.X,t.Y,form1.Handle,nil);
 end;
 end;
end;

procedure TForm1.ControlWindow(Var Msg:TMessage);
begin
 if (Msg.WParam=SC_MINIMIZE)and checkbox3.Checked then
  postmessage(form1.Handle,My_MES,0,WM_LBUTTONDBLCLK)
 else inherited;
End;

procedure TForm1.TrayControl(var Msg: TMessage);
begin
 if LOWORD(Msg.wParam)=1 then  //
  postmessage(form1.Handle,MY_MES,0,WM_LBUTTONDBLCLK)
 else               //
  form1.Close;
end;

procedure TForm1.ColorBtn1Click(Sender: TObject);
begin
 if opendialog1.Execute then
  if opendialog1.FileName<>'' then begin
   ColorBtn1.Hint:='Alarm file: '+opendialog1.FileName;
   ColorBtn1.Caption:='Redefine alarm file';
   opendialog1.InitialDir:=ExtractFilePath(opendialog1.Filename);
  end;
end;

procedure TForm1.ColorBtn2Click(Sender: TObject);
 var CurSec:integer;
begin
 if ColorBtn2.tag=0 then begin  //  
  if (checkbox1.Checked=false)and(checkbox2.Checked=false)and(opendialog1.FileName='') then begin  
   messagebox(form1.Handle,'Define the alarm file.','Attention',MB_ICONASTERISK);
   exit;
  end;
  TargSec:=strtoint(edit3.Text)+60*strtoint(edit2.Text)+3600*strtoint(edit1.Text);
  GetLocalTime(systime);
  prevsec:=systime.wSecond;
  if radiobutton1.Checked then begin  //Timer
   if TargSec=0 then begin
    messagebox(form1.Handle,'Enter the target time.','Attention',MB_ICONASTERISK);
    exit;
   end;
   PrevMls:=systime.wMilliseconds;//        ,     ""
  end else begin //Alarm clock
   PrevMls:=0; //      
   CurSec:=(systime.wSecond+60*systime.wMinute+3600*systime.wHour);
   if TargSec>=CurSec then TargSec:=TargSec-CurSec
                      else TargSec:=86400-CurSec+TargSec;
  end;
  MigC:=0;
  DrawTime;
  activ:=true; //  
  ColorBtn2.tag:=1;
  radiobutton1.Enabled:=false;
  radiobutton2.Enabled:=false;
  UpDown1.Enabled:=false;
  UpDown2.Enabled:=false;
  UpDown3.Enabled:=false;  
  edit1.ReadOnly:=true;
  edit2.ReadOnly:=true;
  edit3.ReadOnly:=true;
  ColorBtn2.Font.Color:=255;
  ColorBtn2.Caption:='STOP';
 end else begin
  activ:=false;
  ColorBtn2.tag:=0;
  radiobutton1.Enabled:=true;
  radiobutton2.Enabled:=true;
  UpDown1.Enabled:=true;
  UpDown2.Enabled:=true;
  UpDown3.Enabled:=true;
  edit1.ReadOnly:=false;
  edit2.ReadOnly:=false;
  edit3.ReadOnly:=false;
  RadioButton1Click(nil);
  ColorBtn2.Font.Color:=0;
  ColorBtn2.Caption:='START';
  StaticText1.color:=0;
  StaticText1.Font.Color:=255;
  StaticText1.Caption:='';
  if mediaplayer1.tag=1 then begin
   mediaplayer1.tag:=0;
   mediaplayer1.Stop;
   mediaplayer1.Close;
  end;
  RadioButton1Click(nil); //     
 end;
end;

procedure TForm1.MediaPlayer1Notify(Sender: TObject);
begin    //  
 if (mediaplayer1.tag=1)and(MediaPlayer1.Position=MediaPlayer1.TrackLength[1]) then MediaPlayer1.Play;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
 if CheckBox3.Checked then begin
 //SetWindowLong(Application.Handle,GWL_EXSTYLE,DefStyle or WS_EX_TOOLWINDOW);
  ShowWindow(Application.Handle,sw_hide);
  shell_notifyicon(nim_add,@my);
 end else begin
 //SetWindowLong(Application.Handle,GWL_EXSTYLE,DefStyle);
  ShowWindow(Application.Handle,sw_show);
  shell_notifyicon(nim_delete,@my);
 end;
end;

end.
